#include "iir.h"
#include "math.h"
//#include <stdio.h>


void iir_2_2_plain (float *source, float *dest, int size)
{
  int i;
  float a0 = 0.4, a1 = 0.3, b1 = 0.2, b2 = 0.1;
  float *sp = source, *dp = dest;
  float y3 = 0.0, y2 = 0.0, y1 = 0.0;
  for (i = size; i > 0; i --)
  {
    y3 = sp[0] * a0 + sp[-1] * a1 + y2 * b1 + y1 * b2;
    *dp = y3;
    y1 = y2;  y2 = y3;
    sp ++;  dp ++;
  }
}

#define shuf __builtin_ia32_shufps

void iir_2_2_vec (float *source, float *dest, int size)
{
  typedef int v4sf __attribute__ ((mode(V4SF)));

  int i;
  float a0 = 0.4, a1 = 0.3, b1 = 0.2, b2 = 0.1;
  float __attribute__ ((aligned (16))) A0_arr[] = {a0, a0, a0, a0};
  v4sf A0 = * (v4sf *) &A0_arr;
  float __attribute__ ((aligned (16))) A1_arr[] = {a1, a1, a1, a1};
  v4sf A1 = * (v4sf *) &A1_arr;
  float __attribute__ ((aligned (16))) B0_arr[] = {b1, b2, 0, b1};
  v4sf B0 = * (v4sf *) &B0_arr;
  float __attribute__ ((aligned (16))) B1_arr[] = {b2, 0, 0, 0};
  v4sf B1 = * (v4sf *) &B1_arr;
  float __attribute__ ((aligned (16))) B2_arr[] = {0, b1, b2, b1*b2};
  v4sf B2 = * (v4sf *) &B2_arr;
  float __attribute__ ((aligned (16))) B3_arr[] = {0, 0, b1, b1*b1+b2};
  v4sf B3 = * (v4sf *) &B3_arr;
  float __attribute__ ((aligned (16))) zero_arr[] = {0, 0, 0, 0};
  v4sf zero = * (v4sf *) &zero_arr;
  float *sp = source, *dp = dest;
  v4sf y = zero, yo, x = zero, xo;

  for (i = size/4; i > 0; i --)
  {
    xo = x;  yo = y;
    x = __builtin_ia32_loadaps (sp);
    y = x * A0 + shuf (shuf (xo, x, select(3,0,0,0)), x, select (0,2,1,2)) * A1;
    y += shuf (yo, y, select (3,3,0,2)) * B0;
    y += shuf (yo, yo, select (2,0,0,0)) * B1;
    y += shuf (y, y, select (0,0,0,0)) * B2;
    y += shuf (y, y, select (0,0,1,1)) * B3;
    __builtin_ia32_storeaps (dp, y);
    sp += 4;  dp += 4;
  }
}
