#include "iir.h"
#include "math.h"
//#include <stdio.h>


void iir_4_9_plain (float *source, float *dest, int size)
{
  int i;
  float a0 = 0.04, a1 = 0.03, a2 = 0.03, a3 = 0.03,
  		b1 = 0.02, b2 = 0.01, b3 = 0.02, b4 = 0.02,
  		b5 = 0.02, b6 = 0.02, b7 = 0.02, b8 = 0.02,
  		b9 = 0.02;

  float *sp = source, *dp = dest;
  float y9=0.0, y8 = 0.0, y7 = 0.0, y6 = 0.0, y5 = 0.0, y4 = 0.0, y3 = 0.0, y2 = 0.0, y1 = 0.0;

  for (i = size; i > 0; i --)
  {
    y9 = sp[0] * a0 + sp[-1] * a1 + sp[-2] * a2 + sp[-3] * a3 +
    		y8 * b1 +
    		y7 * b2 +
    		y6 * b3 +
    		y5 * b4 +
    		y4 * b5 +
    		y3 * b6 +
    		y2 * b7 +
    		y1 * b8;
    *dp = y9;
    y1 = y2;
    y2 = y3;
    y3 = y4;
    y4 = y5;
    y5 = y6;
    y6 = y7;
    y7 = y8;
    y8 = y9;
    sp ++;  dp ++;
  }
}


void iir_4_9_vec (float *source, float *dest, int size)
{
}

/*
#define shuf __builtin_ia32_shufps

void iir_2_2_vec (float *source, float *dest, int size)
{
  typedef int v4sf __attribute__ ((mode(V4SF)));

  int i;
  float a0 = 0.4, a1 = 0.3, b1 = 0.2, b2 = 0.1;
  float __attribute__ ((aligned (16))) A0_arr[] = {a0, a0, a0, a0};
  v4sf A0 = * (v4sf *) &A0_arr;
  float __attribute__ ((aligned (16))) A1_arr[] = {a1, a1, a1, a1};
  v4sf A1 = * (v4sf *) &A1_arr;
  float __attribute__ ((aligned (16))) B0_arr[] = {b1, b2, 0, b1};
  v4sf B0 = * (v4sf *) &B0_arr;
  float __attribute__ ((aligned (16))) B1_arr[] = {b2, 0, 0, 0};
  v4sf B1 = * (v4sf *) &B1_arr;
  float __attribute__ ((aligned (16))) B2_arr[] = {0, b1, b2, b1*b2};
  v4sf B2 = * (v4sf *) &B2_arr;
  float __attribute__ ((aligned (16))) B3_arr[] = {0, 0, b1, b1*b1+b2};
  v4sf B3 = * (v4sf *) &B3_arr;
  float __attribute__ ((aligned (16))) zero_arr[] = {0, 0, 0, 0};
  v4sf zero = * (v4sf *) &zero_arr;
  float *sp = source, *dp = dest;
  v4sf y = zero, yo, x = zero, xo;

  for (i = size/4; i > 0; i --)
  {
    xo = x;  yo = y;
    x = __builtin_ia32_loadaps (sp);
    y = x * A0 + shuf (shuf (xo, x, select(3,0,0,0)), x, select (0,2,1,2)) * A1;
    y += shuf (yo, y, select (3,3,0,2)) * B0;
    y += shuf (yo, yo, select (2,0,0,0)) * B1;
    y += shuf (y, y, select (0,0,0,0)) * B2;
    y += shuf (y, y, select (0,0,1,1)) * B3;
    __builtin_ia32_storeaps (dp, y);
    sp += 4;  dp += 4;
  }
}
*/
